#include "CFProfile.H"

#include "Logger.H"
extern Logger logger;

CFProfile::CFProfile(const string &who,int wdth, int hght,bool brdr, bool shdw):
		Window(wdth,hght,brdr,shdw),
		_running(false),
		_owner(who) {
	_rebld=true;
	_ta=new TextArea(wdth-4,hght-2,128,true,false,true,19);
	(*_ta).style(_stile);
	Window::add("Profile",_ta,2,1);
	fetchProfile(_owner);
}

CFProfile::~CFProfile() {
	delete (_ta);
}

widstat CFProfile::input(Char inp) {
	return (*_ta).input(inp);
}

widstat CFProfile::style(Char stile) {
	_stile=stile;
	_tstile=stile;
	_kstile=stile;
	if (_tstile.isBold())
		_tstile.tBold();
	_tstile.setFore(cc_white);
	_kstile.setFore(cc_green);
	_kstile.tBold();
	(*_ta).style(_tstile);
	_rebld=true;
	return (ws_accepted);
}

int CFProfile::fetchProfile(const string &who) {
	if (_running)
		pthread_cancel(_prunner);
	else
		_running=true;
	_who=who;
	pthread_create(&_prunner,NULL, (void *(*)(void *))threadRunner, this);
	return 0;
}

void *CFProfile::threadRunner(CFProfile *this_) {
	int 
		rv;
	string
		msg;
	Text
		txt,
		blinktxt;
	Char
		stile;

	stile=(*this_)._tstile;
	stile.setFore(cc_white);
	stile.tBlink();
	txt.style((*this_)._tstile);
	blinktxt.style(stile);
	this_->_ta->clear();
	this_->_wtitle=this_->_who;
	this_->_wtitle+="'s Yahoo! Profile";
	msg="Fetching Profile for ";
	msg+=this_->_who;
	msg+="...";
	txt.setText(msg);
	blinktxt.setText(" ");
	txt+=blinktxt;
	this_->_ta->operator+=(txt);
	this_->_rebld=true;
	if ((rv=this_->_yp.fetch(this_->_who))) {
		string line;
		if (rv==1) { 
			line="User not found";
		}
		else {
			line="Error retreiving Profile";
		}
		txt.setText(line);
		this_->_ta->clear();
		this_->_ta->operator+=(txt);
		this_->_rebld=true;
		this_->_running=false;
		return (this_);
	}
	this_->_yp.getVars(this_->_who, this_->_name, this_->_location,
			this_->_age, this_->_mstatus, this_->_sex,
			this_->_occupation, this_->_quote, this_->_hobbies,
			this_->_news, this_->_picture, this_->_online);
	this_->paint();
	this_->_rebld=true;
	this_->_running=false;
	return (this_);
}

void CFProfile::paint() {
	string
		tmp;
	Text
		label,
		txt;

	label.style(_kstile);
	txt.style(_tstile);
	(*_ta).clear();
	txt.setText(" ");
	(*_ta)+=txt;
	tmp="Yahoo! ID:         ";
	label.setText(tmp);
	tmp=_who;
	txt.setText(tmp);
	label+=txt;
	(*_ta)+=label;
	tmp="Online Status:     ";
	label.setText(tmp);
	if (_online)
		tmp="Online";
	else
		tmp="Offline";
	txt.setText(tmp);
	label+=txt;
	(*_ta)+=label;
	if (_name.length()) {
		tmp="Real Name:         ";
		label.setText(tmp);
		tmp=_name;
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
	}
	if (_location.length()) {
		tmp="Location:          ";
		label.setText(tmp);
		tmp=_location;
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
	}
	if (_age.length()) {
		tmp="Age:               ";
		label.setText(tmp);
		tmp=_age;
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
	}
	if (_mstatus.length()) {
		tmp="Marital Status:    ";
		label.setText(tmp);
		tmp=_mstatus;
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
	}
	if (_sex.length()) {
		tmp="Sex:               ";
		label.setText(tmp);
		tmp=_sex;
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
	}
	if (_occupation.length()) {
		tmp="Occupation:        ";
		label.setText(tmp);
		tmp=_occupation;
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
	}
	txt.setText(" ");
	(*_ta)+=txt;
	if (_hobbies.length()) {
		tmp="Hobbies:           ";
		label.setText(tmp);
		tmp=_hobbies;
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
		txt.setText(" ");
		(*_ta)+=txt;
	}
	if (_news.length()) {
		tmp="Latest News:       ";
		label.setText(tmp);
		tmp=_news;
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
		txt.setText(" ");
		(*_ta)+=txt;
	}
	if (_quote.length()) {
		tmp="Quote:             ";
		label.setText(tmp);
		tmp='"';
		tmp+=_quote;
		tmp+='"';
		txt.setText(tmp);
		label+=txt;
		(*_ta)+=label;
		txt.setText(" ");
		(*_ta)+=txt;
	}
	if (_picture.length()) {
		tmp="Picture:";
		label.setText(tmp);
		(*_ta)+=label;
		tmp=_picture;
		txt.setText(tmp);
		(*_ta)+=txt;
	}
	(*_ta).toTop();
}
